﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Seeyon.Entities
{
    #region Request
    public class RequestRestToken
    {
        public string userName { get; set; }
        public string password { get; set; }
        public string loginName { get; set; }
    }
    public class RequestForm<T>
    {
        /// <summary>
        /// 默认值（OA提供）
        /// </summary>
        public string appName { get; set; }

        /// <summary>
        /// 请求参数
        /// </summary>
        public RequestData<T> data { get; set; }
    }

    public class RequestData<T>
    {
        /// <summary>
        /// /默认值，流程模版编码（OA提供）
        /// </summary>
        public string templateCode { get; set; }

        /// <summary>
        /// 0:新建-发送；1:新建-保存待发
        /// </summary>
        public string draft { get; set; }

        /// <summary>
        /// 协同标题区附件，Long型List，值为附件的Id。Id是附件接口响应结果中fileUrl字段的值。
        /// </summary>
        public List<string> attachments { get; set; }

        /// <summary>
        /// 发送人登录名
        /// </summary>
        public string senderLoginName { get; set; }

        /// <summary>
        /// 流程标题
        /// </summary>
        public string subject { get; set; }

        /// <summary>
        /// 具体表单内容
        /// </summary>
        public T data { get; set; }
    }

    #endregion

    #region Response

    public class ResponseForm<T>
    {
        /// <summary>
        /// 返回码
        /// </summary>
        public string code { get; set; }
        public T data { get; set; }
        public string message { get; set; }
    }

    public class ResponseData
    {
        public List<WorkItem> workitems { get; set; }
        public string app_bussiness_data { get; set; }

        /// <summary>
        /// 流程ID(ctp_affair.process_id)
        /// </summary>
        public string processId { get; set; }

        /// <summary>
        /// 标题
        /// </summary>
        public string subject { get; set; }
        public string errorMsg { get; set; }

        public class WorkItem
        {
            public string nodeName { get; set; }
            public string userLoginName { get; set; }
            public string id { get; set; }
            public string userName { get; set; }
            public string nodeId { get; set; }
            public string userId { get; set; }

        }
    }

    public class ResponseToken
    {
        /// <summary>
        /// 
        /// </summary>
        public BindingUser bindingUser { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string userName { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string id { get; set; }

        public class BindingUser
        {
            /// <summary>
            /// 
            /// </summary>
            public string loginState { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string sessionId { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int id { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int securityKey { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string loginName { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string name { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int loginAccount { get; set; }
            /// <summary>
            /// 江苏省纺织产品质量监督检验研究院
            /// </summary>
            public string loginAccountName { get; set; }
            /// <summary>
            /// 单位
            /// </summary>
            public string loginAccountShortName { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string province { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string city { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string rectangle { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string nodeIndex { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int departmentId { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int levelId { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int postId { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int accountId { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string remoteAddr { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string userAgentFrom { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int externalType { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string locale { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int loginTimestamp { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string loginLogId { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string skin { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string userSSOFrom { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string browser { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string timeZone { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string canSendSMS { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string etagRandom { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int changeRoleTimestamp { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string v5Member { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string guest { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string @internal { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string groupSystemAdmin { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string unitSystemAdmin { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int loginSign { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string vjoinMember { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string admin { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string v5External { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string groupAdmin { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string administrator { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string visitor { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string systemAdmin { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string auditAdmin { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string fromM1 { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string platformAdmin { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string superAdmin { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string screenGuest { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string defaultGuest { get; set; }
        }
    }

    public class ResponseAttachment
    {
        /// <summary>
        /// 
        /// </summary>
        public int n_a_s { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public List<AttachmentDetail> atts { get; set; }

        public class AttachmentDetail
        {
            /// <summary>
            /// 
            /// </summary>
            public string id { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string reference { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string subReference { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int category { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int type { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string filename { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string mimeType { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string createdate { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string size { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string description { get; set; }
            /// <summary>
            /// 附件id
            /// </summary>
            public string fileUrl { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string extension { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string icon { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string iconFont { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string genesisId { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public int sort { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string officeTransformEnable { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string obsObjectKey { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string v { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string @new { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public ExtraMap extraMap { get; set; }
        }
        public class ExtraMap
        {
        }
    }

    public class ResponseOrgMember
    {
        /// <summary>
        /// Id，唯一标识人员
        /// </summary>
        public string id { get; set; }

        /// <summary>
        /// 姓名
        /// </summary>
        public string name { get; set; }

        /// <summary>
        /// 登录名
        /// </summary>
        public string loginName { get; set; }

        /// <summary>
        /// 人员编码
        /// </summary>
        public string code { get; set; }

        /// <summary>
        /// 创建时间
        /// </summary>
        public string createTime { get; set; }

        /// <summary>
        /// 更新时间
        /// </summary>
        public string updateTime { get; set; }

        /// <summary>
        /// 排序号
        /// </summary>
        public string sortId { get; set; }

        /// <summary>
        /// 说明
        /// </summary>
        public string description { get; set; }

        /// <summary>
        /// 人员所属单位Id
        /// </summary>
        public string orgAccountId { get; set; }

        /// <summary>
        /// 人员职务级别Id
        /// </summary>
        public string orgLevelId { get; set; }

        /// <summary>
        /// 人员岗位Id
        /// </summary>
        public string orgPostId { get; set; }

        /// <summary>
        /// 人员所属部门Id
        /// </summary>
        public string orgDepartmentId { get; set; }

        /// <summary>
        /// 副岗
        /// </summary>
        public List<SecondPost> second_post { get; set; }

        /// <summary>
        /// 兼职
        /// </summary>
        public List<string> concurrent_post { get; set; }

        /// <summary>
        /// 账户状态：true为启用，false为停用
        /// </summary>
        public string enabled { get; set; }

        /// <summary>
        /// 删除标记：true为已删除
        /// </summary>
        public string isDeleted { get; set; }

        /// <summary>
        /// 是否内部人员
        /// </summary>
        public string isInternal { get; set; }

        /// <summary>
        /// 是否可登录
        /// </summary>
        public string isLoginable { get; set; }

        /// <summary>
        /// 是否已分配人员
        /// </summary>
        public string isAssigned { get; set; }

        /// <summary>
        /// 是否管理员，集团管理员、系统管理员、审计管理员或单位管理员返回true，否则为false
        /// </summary>
        public string isAdmin { get; set; }

        /// <summary>
        /// 是否可用：已删除、被停用、不可登录、未分配或离职人员返回false，否则返回true
        /// </summary>
        public string isValid { get; set; }

        /// <summary>
        /// 人员状态：1为在职，2 为离职
        /// </summary>
        public string state { get; set; }

        /// <summary>
        /// 实体状态：1为正常、2为申请停用、3为申请删除、4为申请调离；此属性不常用，一般返回1
        /// </summary>
        public string status { get; set; }

        /// <summary>
        /// 手机号码
        /// </summary>
        public string telNumber { get; set; }

        /// <summary>
        /// 出生日期
        /// </summary>
        public string birthday { get; set; }

        /// <summary>
        /// 办公电话
        /// </summary>
        public string officeNum { get; set; }

        /// <summary>
        /// 电子邮件
        /// </summary>
        public string emailAddress { get; set; }

        /// <summary>
        /// 性别：-1为未指定、1为男、2为女
        /// </summary>
        public string gender { get; set; }

        /// <summary>
        /// 工作地
        /// </summary>
        public string location { get; set; }

        /// <summary>
        /// 汇报人
        /// </summary>
        public string reporter { get; set; }

        /// <summary>
        /// 入职时间
        /// </summary>
        public string hiredate { get; set; }
    }

    public class SecondPost
    {
        /// <summary>
        /// 
        /// </summary>
        public int memberId { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public int depId { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public int postId { get; set; }
    }
    #endregion
}
